import java.awt.*;
import java.util.Vector;

class Bezier3D {
	
   void calcola(Vector punti, int iterazioni, Coordinate3D[] curva) {
      // calcola la curva
      for (int i=0; i<iterazioni; i++) 
			curva[i]=bezier( ((float)i) / (iterazioni-1), punti);
   }
	
   private int bin(int n,int i) { // funzione binomiale
      float j;
      float b=1;
      
		for (j=1; j<=n-i; j++)
			b*=((j+i)/j);
      return (int) b;
   }
	
   private Coordinate3D bezier(float u,Vector punti) { // calcola il valore della curva di Bezier nel punto
      int i;
      double b,x=0,y=0,z=0;
      int grado=punti.size()-1;
		
		for (i=0; i<=grado; i++) {
         b = bin(grado,i) * Math.pow(1-u,(float)grado-i) * Math.pow(u,(float) i); // calcola il polinomio di Bernstein
         x += (((Coordinate3D)punti.elementAt(i)).x)*b;
         y += (((Coordinate3D)punti.elementAt(i)).y)*b;
         z += (((Coordinate3D)punti.elementAt(i)).z)*b;
      }
      return new Coordinate3D((int)x,(int)y,(int)z);
   }
}