import java.awt.*;
import java.util.Vector;

class PianoProiez extends Piano {
   Grafica grafica;
   Proiezione proiez;
   Viste viste;
   Vector punti;
	
   PianoProiez(Viste viste) {
      grafica=new Grafica(getGraphics());      
      this.viste=viste;
      punti=viste.punti;
   }
	
   public void paint(Graphics g) {
		if (viste.modProiezione) {
			proiez=new Proiezione(viste.occhio,viste.target,size().width,size().height);
			viste.modProiezione=false;
		}
		g.setColor(Color.gray);
		g.drawRect(0,0,size().width-2,size().height-2);
		g.drawString("NON IMPLEMENTATA",20,size().height/2);
		grafica=new Grafica(g);
		grafica.impostaColore(Color.orange);
		for (int i=0; i<punti.size()-1; i++)
         disegnaLinea(((Coordinate3D)punti.elementAt(i)),((Coordinate3D)punti.elementAt(i+1)));
      if (viste.daDisegnare() || disegnaCurva) {
			grafica.impostaColore(Color.black);
			for (int i=0; i<viste.curva.length-1; i++) {
				disegnaLinea(viste.curva[i],viste.curva[i+1]);
			}
			disegnaCurva=false;
		}
	}	
	
	void impostaColore(Color colore) {
		grafica.impostaColore(colore);
	}
	
	void vaiA(Coordinate3D coord) {
		grafica.vaiA(proiez.proietta(coord));
	}
		
	void disegnaLineaA(Coordinate3D coord) {
		grafica.disegnaLineaA(proiez.proietta(coord));
	}
	
	void disegnaLinea(Coordinate3D da,Coordinate3D a) {
		if (da==null || a==null) return;		
		grafica.disegnaLinea(proiez.proietta(da),proiez.proietta(a));
	}	
}