import java.awt.*;
import java.util.Vector;

class Bspline {
   Vector punti;
   private int n;
   private int k;
	
   Bspline(Vector punti, int continuita,int iterazioni, Graphics g) {
      int i,a,b;
      float u,inc;
      Coordinate2D valorePunto;
      this.punti =punti;
      k=continuita;
		
      // disegna la curva
      n=punti.size();
      Grafica grafica = new Grafica(g);
      grafica.impostaColore(Color.black);
      a=0; b=n-k; // intervallo di definizione della u
      inc=(float)(b-a)/iterazioni; // incremento del parametro
      u=a;
		if (b>0) {
			valorePunto = funzioneP(k,(int)Math.floor(u)+k,u);
			grafica.vaiA(valorePunto);
			
			for (i=0; i<iterazioni-1; i++) {
				u += inc;
				valorePunto = funzioneP(k,(int)Math.floor(u)+k,u);  
				grafica.disegnaLineaA(valorePunto);
			}
			grafica.disegnaLineaA((Coordinate2D)punti.elementAt(n-1));
		}
	}
	
	private Coordinate2D funzioneP(int r,int i,float u){
		return new Coordinate2D((int)xP(r,i,u),(int)yP(r,i,u));
	}
		
	private double xP(int r,int i,float u) {
		float x;   
		if (r==0) {
			return ((Coordinate2D)punti.elementAt(i)).x;
		}
		else return x=(float)((u-t(i))*xP(r-1,i,u)+(t(i+k-(r-1))-u)*xP(r-1,i-1,u))/(t(i+k-(r-1))-t(i));
	}	
	
	private double yP(int r,int i,float u) {
		float y;
		if (r == 0) {
			return ((Coordinate2D)punti.elementAt(i)).y;
		}
		else return y=(float)((u-t(i))*yP(r-1,i,u)+(t(i+k-(r-1))-u)*yP(r-1,i-1,u))/(t(i+k-(r-1))-t(i));
	}

	private int t(int i) {
		if (i<=k) return 0;
		else if (i>=n) return n-k;
		else return i-k;
	}
}
