import java.awt.*;
import java.util.Vector;

class PianoOrtog extends Piano {
	Grafica grafica;
	int id;
	Viste viste;
	Vector punti;
	
	PianoOrtog(int id,Viste viste) {
		grafica=new Grafica(getGraphics());
		this.id=id;
		this.viste=viste;
		punti=viste.punti;
	}
	
	public void paint(Graphics g) {
		String stringaId;
		g.setColor(Color.gray);
		g.drawRect(0,0,size().width-2,size().height-2);
		switch (id) {
		case Viste.XY:
			stringaId="XY";
			break;
		case Viste.ZY:
			stringaId="ZY";
			break;
		case Viste.XZ:
			stringaId="XZ";
			break;
		}
		g.drawString(stringaId,size().width-22,size().height-4);
		grafica=new Grafica(g);
		grafica.impostaColore(Color.orange);
		for (int i=0; i<punti.size()-1; i++)
			disegnaLinea(((Coordinate3D)punti.elementAt(i)),((Coordinate3D)punti.elementAt(i+1)));
		for (int i=0; i<punti.size(); i++) {
			PuntoDiControllo3D punto=(PuntoDiControllo3D)punti.elementAt(i);			
			punto.disegna(g,i,id);			
		}	
		if (viste.daDisegnare() || disegnaCurva) {
			grafica.impostaColore(Color.black);
			for (int i=0; i<viste.curva.length-1; i++) {
				disegnaLinea(viste.curva[i],viste.curva[i+1]);
			}
			disegnaCurva=false;
		}
		viste.occhio.disegna(g,"E",Color.blue,id);			
		viste.target.disegna(g,"T",Color.red,id); 		
	}
	
	void impostaColore(Color colore) {
		grafica.impostaColore(colore);
	}
	
	void vaiA(Coordinate3D coord) {
		switch (id) {
		case Viste.XY:
			grafica.vaiA(coord.x,coord.y);
			break;
		case Viste.ZY:
			grafica.vaiA(coord.z,coord.y);
			break;
		case Viste.XZ:
			grafica.vaiA(coord.x,coord.z);
			break;
		default:
			/*niente*/
		}			
	}
	
	void disegnaLineaA(Coordinate3D coord) {
		switch (id) {
		case Viste.XY:
			grafica.disegnaLineaA(coord.x,coord.y);
			break;
		case Viste.ZY:
			grafica.disegnaLineaA(coord.z,coord.y);
			break;
		case Viste.XZ:
			grafica.disegnaLineaA(coord.x,coord.z);
			break;
		default:
			/*niente*/
		}
	}
	
	void disegnaLinea(Coordinate3D da,Coordinate3D a) {
		if (da==null || a==null) return; 	
		switch (id) {
		case Viste.XY:
			grafica.disegnaLinea(da.x,da.y,a.x,a.y);
			break;
		case Viste.ZY:
			grafica.disegnaLinea(da.z,da.y,a.z,a.y);
			break;
		case Viste.XZ:
			grafica.disegnaLinea(da.x,da.z,a.x,a.z);
			break;
		default:
			/*niente*/
		}
	}
	
	private int individuaPuntoA(int a, int b) {
		if ((viste.occhio).vicinoA(a,b,id)) return -2;
		if ((viste.target).vicinoA(a,b,id)) return -3;
		for(int i=0; i<punti.size(); i++)
			if (((PuntoDiControllo3D)viste.punti.elementAt(i)).vicinoA(a,b,id))
			return i;
		/*else*/ return -1;
	}
	
	public boolean handleEvent(Event ev) {
		switch (ev.id) {
		case Event.MOUSE_DOWN:
			switch (viste.modPunti) {
			case Viste.AGG_PUNTO:
				switch (id) {
				case Viste.XY:
					viste.punti.addElement(new PuntoDiControllo3D(ev.x,ev.y,10));
					viste.repaint();			
					break;
				case Viste.ZY:
					viste.punti.addElement(new PuntoDiControllo3D(10,ev.y,ev.x));
					viste.repaint();
					break;
				case Viste.XZ:
					viste.punti.addElement(new PuntoDiControllo3D(ev.x,10,ev.y));
					viste.repaint();
					break;
				}	 
				break;
				case Viste.MUOVI_PUNTO:
					viste.puntoInMov=individuaPuntoA(ev.x,ev.y); 
					break;
				case Viste.CANC_PUNTO:
					int idPunto=individuaPuntoA(ev.x,ev.y);
					if(idPunto>=0) {
						viste.punti.removeElementAt(idPunto);
						viste.repaint();
					}
					break;
				default:
					throw new IllegalArgumentException();
			}
			return true;
			case Event.MOUSE_UP:
				if (viste.puntoInMov!=-1) {
					viste.puntoInMov=-1;
					repaint();
				}
				return true;
			case Event.MOUSE_DRAG:
				if (viste.puntoInMov!=-1) {
					switch (id) {
					case Viste.XY:
						switch (viste.puntoInMov) {
						case -2:
							viste.occhio.x=ev.x;
							viste.occhio.y=ev.y;
							viste.modProiezione=true;
							break;
						case -3:
							viste.target.x=ev.x;
							viste.target.y=ev.y;
							viste.modProiezione=true;
							break;
						default:
							((PuntoDiControllo3D) punti.elementAt(viste.puntoInMov)).x=ev.x;
							((PuntoDiControllo3D) punti.elementAt(viste.puntoInMov)).y=ev.y;
						}
						break;
						case Viste.ZY:
							switch (viste.puntoInMov) {
							case -2:
								viste.occhio.z=ev.x;
								viste.occhio.y=ev.y;
								viste.modProiezione=true;
								break;
							case -3:
								viste.target.z=ev.x;
								viste.target.y=ev.y;
								viste.modProiezione=true;
								break;
							default:
								
								((PuntoDiControllo3D) punti.elementAt(viste.puntoInMov)).z=ev.x;
								((PuntoDiControllo3D) punti.elementAt(viste.puntoInMov)).y=ev.y;
							}
							break;
							case Viste.XZ:
								switch (viste.puntoInMov) {
								case -2:
									viste.occhio.x=ev.x;
									viste.occhio.z=ev.y;
									viste.modProiezione=true;
									break;
								case -3:
									viste.target.x=ev.x;
									viste.target.z=ev.y;
									viste.modProiezione=true;
									break;
								default:
									
									((PuntoDiControllo3D) punti.elementAt(viste.puntoInMov)).x=ev.x;
									((PuntoDiControllo3D) punti.elementAt(viste.puntoInMov)).z=ev.y;
								}
								break;					
					}
					viste.repaint();
				} 
				return true;
			default:
				return false;
		}
	}	  
}