import java.awt.*;
import java.util.Vector;

class Viste extends Panel {
   public static final int AGG_PUNTO = 0;
	public static final int MUOVI_PUNTO = 1;
	public static final int CANC_PUNTO = 2;
	int modPunti = AGG_PUNTO;
	Vector punti = new Vector(16,4);
   int puntoInMov=-1;
	PuntoDiControllo3D occhio, target;
	boolean modProiezione=true;
  	private boolean disegnaCurva=false;
   private boolean ridisegnaAutomaticamente=false;
   private int iterazioni;
   public static final int XY = 0;
	public static final int ZY = 1;
	public static final int XZ = 2;	
   Piano[] piani;
	private Bezier3D bezier3D;
	Coordinate3D[] curva;
	
   Viste() {
      setLayout(new GridLayout(2,2));
		setBackground(Color.white);
      piani=new Piano[4];
      piani[0]=new PianoOrtog(XY,this);
      piani[1]=new PianoOrtog(ZY,this);
      piani[2]=new PianoOrtog(XZ,this);
      piani[3]=new PianoProiez(this);
      for (int id=0; id<4; id++)
         add(piani[id]);
		occhio=new PuntoDiControllo3D(50,50,50);
      target=new PuntoDiControllo3D(100,100,100);
		bezier3D=new Bezier3D();
		curva=new Coordinate3D[0];
	}	
   
   void disegna() {
		for (int id=0; id<4; id++)
			piani[id].disegnaCurva=true;
		disegnaCurva=true;
      repaint();
	}
	
   void impostaRidisAut(boolean dis) {
      ridisegnaAutomaticamente=dis;
      repaint();
	}
	
   boolean leggiRidisAut() {
      return ridisegnaAutomaticamente;      
	}	
	
   boolean daDisegnare() {
      return (ridisegnaAutomaticamente || disegnaCurva);      
	}	
	
	void impostaModPunti(int mod) {
		modPunti=mod;
	}
	
	void impostaIterazioni(int iter) {
		if (iter>0) {
			iterazioni=iter;
			curva=new Coordinate3D[iterazioni];
		}
      repaint();
	}
	
	void eliminaPunti() {
		punti.removeAllElements();
      repaint();
	}

	public void paint(Graphics g) {
      int i;
      if (daDisegnare())
			bezier3D.calcola(punti,iterazioni,curva);
		for (int id=0; id<4; id++) piani[id].repaint();
      disegnaCurva=false;
	}
}